
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <SDL.h>
#include "koelli.h"
#include "syna.h"

int quit=0;
extern char biisi[];
extern void analyysi(void *);
extern int osa(int);

#ifndef BLKSIZE
#define BLKSIZE 1024
#endif

#define MAXMIX (2*60*44100+BLKSIZE)
short mixed[MAXMIX*2];

void pakki(void *udata, Uint8 *stream, int len)
{
    memcpy(stream,&mixed[syna_counter*2],len);
    syna_counter+=len/4;
//    analyysi(stream);
}

int main(int argc,char *argv[])
{
    int orig,raamit=0,finaltid,off,loop=0;
    SDL_Event e;
    SDL_AudioSpec w;

    // Prekalk sound
    printf("Measuring CPU speed");
    syna_init(44100);
    if(syna_get(biisi)<0)
        return(EXIT_FAILURE);
    for(off=0;off<MAXMIX*2;)
    {
        syna_play(&mixed[off],BLKSIZE);
        off+=BLKSIZE*2;
        loop=(loop+1)&7;
        if(!loop)
        {
            printf(".");
            fflush(stdout);
        }
    }
    syna_counter=0;

    SDL_Init(SDL_INIT_AUDIO|SDL_INIT_TIMER);

    w.freq=44100;
    w.format=AUDIO_S16SYS;
    w.samples=BLKSIZE;
    w.channels=2;
    w.callback=pakki;
    w.userdata=NULL;
    SDL_OpenAudio(&w,NULL);

    koelli_open(640,480,32,0);

    SDL_WM_SetCaption("Yellow Rose of Texas",0);
    SDL_ShowCursor(0);

    SDL_PauseAudio(0);

    orig=SDL_GetTicks();
    while(!koelli_exitevent() && !quit)
    {
        if(osa(SDL_GetTicks()-orig))
        {
            koelli_flip();
            raamit++;
        }
    }
    finaltid=SDL_GetTicks()-orig;

    koelli_close();

    printf("\nFPS: %d\n",raamit*1000/finaltid);
    return(0);
}
